#include <allegro5/allegro.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_ttf.h>
#include <iostream>
#include <stdio.h>

#define ButtonSize 30

class Button
{

public:
	int x1 = 0;
	int y1 = 0;
	int x2 = 0;
	int y2 = 0;
	int Hover = 0;
	char *value = "";
	ALLEGRO_FONT *font;
	Button() {};
	Button(int nx1, int ny1, char *val, ALLEGRO_FONT *font1)
	{
		x1 = nx1;
		x2 = nx1 + strlen(val) * 20 + ButtonSize;
		y1 = ny1;
		y2 = ny1 + 10 + ButtonSize;
		value = val;
		font = font1;
	}

	void DrawButton(void)
	{
		al_draw_filled_rounded_rectangle(x1, y1, x2, y2, 4, 4, al_map_rgb(50, 50, 50));
		al_draw_rounded_rectangle(this->x1, this->y1, this->x2, this->y2, 4, 4, al_map_rgb(200, 200, 200), 2);
		al_draw_textf(font, al_map_rgb(255, 255, 255), x1 + ((x2 - x1) - 20 * (strlen(value))) / 2 + 20, y1 + 8, ALLEGRO_ALIGN_LEFT, value);
	}
	void DrawButtonHover(void)
	{
		al_draw_filled_rounded_rectangle(x1, y1, x2, y2, 4, 4, al_map_rgb(20, 20, 20));
		al_draw_rounded_rectangle(this->x1, this->y1, this->x2, this->y2, 4, 4, al_map_rgb(200, 200, 200), 2);
		al_draw_textf(font, al_map_rgb(255, 255, 255), x1 + ((x2 - x1) - 20 * (strlen(value))) / 2 + 20,  y1+8, ALLEGRO_ALIGN_LEFT, value);
	}
};